<?

mt_srand((double)microtime()*1000000);

## Datencontainer, fr einen Artikel (MP3-Beitrag) in podblogger

class article {

  // ------------------------------------------------------------
  // Klassen-Variablen
  // ------------------------------------------------------------

  var $id 				= 0;
  var $unixTime 		= 0;
  var $file 			= "";
  var $title 			= "";
  var $description 		= "";
  var $authorName 		= "";
  var $authorMail 		= "";
  var $authorXtra 		= "";
  var $authorComment 	= "";
  var $category 		= "";

  // Jedes Kommentar zu einem Beitrag ist ein Objekt
  var $commentObjects 	= array();

  // Gibt Auskunft, ob dieses Objekt schon VALID ist
  var $objectState 	  	= "INIT";

  // ------------------------------------------------------------
  // Konstruktor
  // ------------------------------------------------------------

  // $id sollte immer eine einzigartige ID sein ... zB time().rand(..)
  function article($id)
  {
    $this->id = $id;
  }

  // ------------------------------------------------------------
  // Setter-Funktionen
  // ------------------------------------------------------------

  function setUnixTime($data)
  {
    if (!is_numeric($data)) {return FALSE;}
    $this->unixTime = $data;
    $this->checkValid();
  }

  function setTitle($data)
  {
    $this->title = $data;
    $this->checkValid();
  }

  function setFile($data)
  {
    $this->file = $data;
  }

  function setDescription($data)
  {
    $this->description = $data;
  }

  function setAuthorName($data)
  {
    $this->authorName = $data;
  }

  function setAuthorMail($data)
  {
    $this->authorMail = $data;
  }

  function setAuthorXtra($data)
  {
    $this->authorXtra = $data;
  }

  function setAuthorComment($data)
  {
    $this->authorComment = $data;
  }

  function setCategory($data)
  {
    $this->category = $data;
  }

  // ------------------------------------------------------------
  // Getter-Funktionen
  // ------------------------------------------------------------

  function getUnixTime()
  {
    if (!isset($this->unixTime)) {$this->unixTime = time();}
    return $this->unixTime;
  }

  function getTitle()
  {
    if (!isset($this->title)) {$this->title = "Without a title";}
    return $this->title;
  }

  function getFile()
  {
    if (!isset($this->file)) {$this->file = "";}
    return $this->file;
  }

  function getDescription()
  {
    if (!isset($this->description)) {$this->description = "";}
    return $this->description;
  }
  function getAuthorName()
  {
    if (!isset($this->authorName)) {$this->authorName = "";}
    return $this->authorName;
  }

  function getAuthorMail()
  {
    if (!isset($this->authorMail)) {$this->authorMail = "";}
    return $this->authorMail;
  }

  function getAuthorXtra()
  {
    if (!isset($this->authorXtra)) {$this->authorXtra = "";}
    return $this->authorXtra;
  }

  function getAuthorComment()
  {
    if (!isset($this->authorComment)) {$this->authorComment = "";}
    return $this->authorComment;
  }

  function getCategory()
  {
    if (!isset($this->category)) {$this->category = "";}
    return $this->category;
  }

  function getState()
  {
    return $this->objectState;
  }

  function getID()
  {
    return $this->id;
  }

  function getArrayOfComments()
  {
    if (!isset($this->commentObjects)) {$this->commentObjects = array();}
    return $this->commentObjects;
  }

  // ------------------------------------------------------------
  // Weitere Aktionen auf Objekt
  // ------------------------------------------------------------

  // fgt dem Artikel ein Kommentar-Objekt hinzu
  function addComment($commentObject)
  {
    if (!isset($this->commentObjects)) {$this->commentObjects = array();}
    array_push($this->commentObjects,$commentObject);
    return TRUE;
  }

  // speicher das Artikel-Objekt als article-Datei im angegebenen Verzeichnis
  function save($dir)
  {
    $data_str = serialize($this);
    if ($fp = fopen($dir."/".$this->id.".article","w"))
    {
      fwrite($fp,$data_str);
      fclose($fp);
      return TRUE;
    }
    return FALSE;
  }

  // Ein Artikel ist gltig (VALID) , wenn ID, UNIXTIME und ein TITEL gesetzt sind
  function checkValid()
  {
    if ($this->id == 0) 	  {return FALSE;}
    if ($this->unixTime == 0) {return FALSE;}
    if ($this->title == "")	  {return FALSE;}

    $this->objectState = "VALID";
    return TRUE;
  }

  // ------------------------------------------------------------
  // Statische Funktionen
  // ------------------------------------------------------------

  // Erstellt ein article-Objekt aus einer article-Datei
  function loadArticleFromFile($file)
  {
    // prfen ob es eine article-Datei ist
    $teile = explode(".",$file);
    if (array_pop($teile) == "article")
    {
      if ((file_exists($file)) && ($fp = fopen($file,"r")))
      {
        $object_str = implode("",file($file));
        return unserialize($object_str);
      }
      else
      {
        return FALSE;
      }
    }
    else
    {
      return FALSE;
    }
  }

  // liefert ein Relais-Objekt direkt vom Auto-Relais-Script aus dem Netz
  // $file  = Alter inf-File
  // $newID = die ID unter der der Artikel laufen soll
  function convert_ArrayInf_2_ObjectInf($file,$newID)
  {
     // Wenn Datei existiert, den alten Array laden
     if (file_exists($file))
     {
        // --------- prfen, ob es sich um eine alte Version handelt
        $test_str = 'O:7:"article"';
        $inf = fopen($file,"r");
        $datstr = fread($inf,25);
        fclose($inf);

        if (strstr($datstr,$test_str) != FALSE)
        {
          // Die Datei schein bereits auf dem neuesten Stand zu sein
          //print "$file ist bereits ein objekt<br>";
          return FALSE;
        }

        // ----------- Array aus alter Dateistruktur laden und in neues Objekt bertragen
        $artikel = new article($newID);

        $infData = array();
        $inf = fopen($file,"r");

        // ZEIT
        $data = article::freadLine($inf);
        if (strlen($data)==0) {$data = "0";}
        $artikel->setUnixTime($data);

        // DATEINAME
        $data = article::freadLine($inf);
        $data = stripslashes($data);
        if (strlen($data)==0) {$data = "";}
        $artikel->setFile($data);

        // TITEL
        $data = article::freadLine($inf);
        $data = stripslashes($data);
        if (strlen($data)==0) {$data = "";}
        $artikel->setTitle($data);

        // BESCHREIBUNG
        $data = article::freadLine($inf);
        $data = stripslashes($data);
        $data = str_replace("\r\n","\n",$data);
        $data = str_replace("\n\r","\n",$data);
        $data = str_replace("\r\n","\n",$data);
        $data = str_replace("<br>","\n",$data);                        
        $data = strip_tags($data);        
        if (strlen($data)==0) {$data = "";}
        $artikel->setDescription($data);

        // AUTOR_NAME
        $data = article::freadLine($inf);
        $data = stripslashes($data);
        if (strlen($data)==0) {$data = "";}
        $artikel->setAuthorName($data);

        // AUTOR_MAIL
        $data = article::freadLine($inf);
        $data = stripslashes($data);
        if (strlen($data)==0) {$data = "";}
        $artikel->setAuthorMail($data);

        // AUTOR_TELEFON
        $data = article::freadLine($inf);
        $data = stripslashes($data);
        if (strlen($data)==0) {$data = "";}
        $artikel->setAuthorXtra($data);

        // AUTOR BEMERKUNG
        $data = article::freadLine($inf);
        $data = stripslashes($data);
        if (strlen($data)==0) {$data = "";}
        $artikel->setAuthorComment($data);

        // KATEGORIE
        $data = article::freadLine($inf);
        $data = stripslashes($data);
        if (strlen($data)==0) {$data = "";}
        $artikel->setCategory($data);

        fclose($inf);

        // Wenn Objekt gltig ....
        if ($artikel->checkValid())
        {
          // Verzeichnis aus $file extrahieren
          $teile = explode("/",$file);
          array_pop($teile);
          $dir = implode("/",$teile);

          // Objekt speichern
          $artikel->save($dir);

          // Alte Inf-Datei umbennen bzw. lschen
          if (!rename($file,$file.".bak")) {@unlink($file);}
        }

        return TRUE;
     }
     else
     {
      //print "$file existiert nicht.<br>";
      return FALSE;
     }
  }

  function createUniqueID()
  {
    $randZahl = mt_rand(1000,9999);
    return time().$randZahl;
  }


  // Wird fr das lesen der alten inf-Datei bentigt
  function freadLine($dat)
  {
    $out = "";
    $lastChar = "";
    while((!feof($dat)) && ($lastChar!="\n"))
    {
      $out = $out.$lastChar;
      $lastChar = fgetc($dat);
    }
    return $out;
  }

}

?>