<?

## Datencontainer, fr Plugin-Layout von podblogger

define("LAYOUTDIR","layoutPlugins");
define("LAYOUTCONFIGDIR","podbloggerData/layoutConfigs");

class layout {

  // ------------------------------------------------------------
  // Klassen-Variablen
  // ------------------------------------------------------------

  var $layoutID		= "";	// ist der Verzeichnisname des Layouts
  var $name 		= "";
  var $author 		= "";
  var $hoemepage 	= "";

  var $defArray 	= array();


  // Gibt Auskunft, ob dieses Objekt schon VALID ist
  var $objectState 	  	= "INIT";

  // ------------------------------------------------------------
  // Konstruktor
  // ------------------------------------------------------------

  // Layouts werden aus einer Datei geladen ...
  // selten von auen initialisiert.
  function layout($id)
  {
    $this->layoutID = $id;
  }

  // ------------------------------------------------------------
  // Setter-Funktionen
  // ------------------------------------------------------------

  function setName($data)
  {
    if ($data == "VOID") {$data = "";}
    $this->name = $data;
  }

  function setAuthor($data)
  {
    if ($data == "VOID") {$data = "";}
    $this->author = $data;
  }

  function setHomepage($data)
  {
    if ($data == "VOID") {$data = "";}
    $this->homepage = $data;
  }

  function addDefinition($data)
  {
    if (count($data) >=2 )
    array_push($this->defArray,$data);
  }

  function setDefinitionValue($defName, $defValue)
  {
    $i = 0;
    while (isset($this->defArray[$i]))
    {
      if ($this->defArray[$i]['smartyname'] == $defName) {$this->defArray[$i]['value']=$defValue; return TRUE;}
      $i++;
    }
    return FALSE;
  }

  // ------------------------------------------------------------
  // Getter-Funktionen
  // ------------------------------------------------------------

  function getName()
  {
    return $this->name;
  }

  function getAuthor()
  {
    return $this->author;
  }

  function getHomepage()
  {
    return $this->homepage;
  }

  function getID()
  {
    return $this->layoutID;
  }

  function getDefinitionArray()
  {
    return $this->defArray;
  }

  function getDefinitionValue($defName)
  {
    foreach ($this->defArray as $def)
    {
      if ($def['smartyname'] == $defName)
      {
        if (isset($def['value']))
        {return $def['value'];}
      }
    }
    return "";
  }

  // ------------------------------------------------------------
  // Weitere Aktionen auf Objekt
  // ------------------------------------------------------------

  // Ein Artikel ist gltig (VALID) , wenn ...
  // ... Name und ID gesetzt
  // ... folgende Layout-Template-Dateien im Layoutordner zu finden sind
  // - index.tpl
  // - upload_1.tpl
  // - upload_2.tpl
  // - upload_3.tpl
  // - upload_error.tpl

  function checkValid()
  {
    if ($this->objectState == "VALID") {return TRUE;}

    if ($this->layoutID == "") 	  {return FALSE;}
    if ($this->name     == "")    {return FALSE;}

    if (!file_exists(LAYOUTDIR."/".$this->layoutID."/index.tpl")) 			{return FALSE;}
    if (!file_exists(LAYOUTDIR."/".$this->layoutID."/upload_1.tpl")) 		{return FALSE;}
    if (!file_exists(LAYOUTDIR."/".$this->layoutID."/upload_1.tpl")) 		{return FALSE;}
    if (!file_exists(LAYOUTDIR."/".$this->layoutID."/upload_1.tpl"))		{return FALSE;}
    if (!file_exists(LAYOUTDIR."/".$this->layoutID."/upload_error.tpl"))	{return FALSE;}

    $this->objectState = "VALID";
    return TRUE;
  }

  function loadDefinitionValues()
  {
     $file = LAYOUTCONFIGDIR."/layout_".$this->layoutID.".conf";
     if (file_exists($file))
     {
       if ($fp = fopen($file,"r"))
       {
         $object_str = implode("",file($file));
         $valueArray = unserialize($object_str);

         // bertragung der gespeicherten Definitionswerte in das aktuelle DefinitionsArray
         $i = 0;
         while (isset($this->defArray[$i]))
         {
           if (isset($valueArray[$this->defArray[$i]['smartyname']]))
           {
             $this->defArray[$i]['value'] = $valueArray[$this->defArray[$i]['smartyname']];
           }
           $i++;
         }

       }
     }
     else return FALSE;
  }

  function saveDefinitionValues()
  {
    $file = LAYOUTCONFIGDIR."/layout_".$this->layoutID.".conf";

    $saveArray = array();
    // Array mit den Definitionswerten anlegen
    foreach ($this->defArray as $def)
    {
      if (isset($def['value']))
      {$saveArray[$def['smartyname']] = $def['value'];}
    }

    $data_str = serialize($saveArray);
    if ($fp = fopen($file,"w"))
    {
      fwrite($fp,$data_str);
      fclose($fp);
      return TRUE;
    }
    return FALSE;
  }

  // ------------------------------------------------------------
  // Statische Funktionen
  // ------------------------------------------------------------

  // Ld ein layout-Objekt aus einem PluginVerzeichnis
  function loadLayoutFromPluginDir($dir)
  {
    // prfen ob es eine layout_definition.txt datei gibt
    if (file_exists(LAYOUTDIR."/".$dir."/layout_definition.txt"))
    {
      // Das LAYOUT-OBJEKT
      $o_layout = new layout($dir);

      $lines = file(LAYOUTDIR."/".$dir."/layout_definition.txt");

      // Die Zeilen der Datei bereiningen und sortieren
      $data_lines 	= array();
      $def_lines	= array();
      foreach ($lines as $line)
      {
        // Zeilenumbruch entfernen
        $line = trim(chop($line));
        // Leer- und Kommentarzeilen entfernen
        if ( (strlen($line) > 0) && (!(substr($line,0,2)=="//")) )
        {
          if ((substr($line,0,5)=="TEXT(")) {array_push($def_lines,$line);}
          else {array_push($data_lines,$line);}
        }
      }

      // Daten-Array auswerten
      if (isset($data_lines[0])) {$o_layout->setName($data_lines[0]);}
      if (isset($data_lines[1])) {$o_layout->setAuthor($data_lines[1]);}
      if (isset($data_lines[2])) {$o_layout->setHomepage($data_lines[2]);}

      // Definitions-Array auswerten
      foreach ($def_lines as $line)
      {
        // TEXT( entfernen
        $line = substr($line,5);
        // Hinterste Klammer entfernen
        $line = substr($line,0,strlen($line)-1);
        // In Datenfelder splitten
        $felder = explode(")/(",$line);

        $definition = array();
        if (count($felder) >= 2)
        {
          // Pflichtfelder
          $definition['smartyname'] 	= $felder[0];
          $definition['description'] 	= $felder[1];

          // optionale Felder
          if (isset($felder[2])) {$definition['maxlength'] = $felder[2];}

          // Definition dem Layout hinzufgen
          $o_layout->addDefinition($definition);
        }
      } // end foreach $def_lines

      // Wenn Layout gltig ist, dann zurckgeben
      if ($o_layout->checkValid())
      {
        $o_layout->loadDefinitionValues();
        return $o_layout;
      }
      else
      {
        //print ("// not valid");
        return FALSE;
      }

    } // end file_exists
    else
    {
      //print ("// es existiert keine layout_definition.txt datei");
      return FALSE;
    }
  }

  // Wird fr das lesen der alten inf-Datei bentigt
  function getAllLayoutPlugIns()
  {
     $layout_array = array();

     // Alle Unterverzeichnisse in Layout-Verzeichnis zusammenstellen
     $layout_dirs = array();
     $handle = opendir(LAYOUTDIR);
     while ($file = readdir($handle))
     {
       if (is_dir(LAYOUTDIR."/".$file))
       {
         array_push($layout_dirs, $file);
       }
     }

     // schauen welches Verzeichnis davon ein gltiges Layout-Plugin ist
     foreach ($layout_dirs as $dir)
     {
       if ($o_layout = layout::loadLayoutFromPluginDir($dir))
       {
         array_push($layout_array, $o_layout);
       }
     }

     // Array-Rckgabe
     if (count($layout_array) > 0) 	{return $layout_array;}
     else							{return FALSE;}
  }

}

?>