<?
  #################################################
  # Konfigurationsfunktionen fr podblogger       #
  # by Christian Rotzoll                          #
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #                                               #
  #################################################
  # Konfigurationsfunktionen                      #
  #################################################

  require("include/ConfigTool.class.php");
  define("CONFIGFILE_PATH","podbloggerData/");

  ####################################################################
  # INIT-WORK
  ####################################################################
  #
  # Dieser include-File wird von jedem podblogger-script verwendet.
  # Einbindung ber "include/funktions_sammlung.inc.php"
  # Folgende Zeilen werden daher bei jedem Aufruf eines podbloggerscripts
  # ausgefhrt:
  #
  ####################################################################

  // Default ConfigWerte --------------------------------------------
  // Werden benutzt, wenn eine neue Config-Datei beim ersten Start von podblogger geschrieben wird

  $defValues = array();

  // Neue Konfig-Werte einfach einmal mit der funktion addDefaultConfig(CONFIG_KEY,CONFIG_DEFAULTVALUE)
  // hier eintragen und beim nchsten Laden des Configfiles (bei jedem Scriptaufruf) wird der Wert
  // eingetragen.

  addDefaultConfig("PODBLOGGER_VERSION","0.4");
  addDefaultConfig("PODBLOGGER_STATUS","INSTALL");
  addDefaultConfig("PODBLOGGER_NEXTSTEP","INSTALLCHECK_START");
  addDefaultConfig("PODCAST_NAME","Mein erster Podblogger");
  addDefaultConfig("PODCAST_DESCRIPTION","");
  addDefaultConfig("PODCAST_CATEGORY",array("Allgemein","Moderation","Verschiedenes"));

  addDefaultConfig("ADMIN_PASSWORD","");
  addDefaultConfig("ADMIN_NAME","");
  addDefaultConfig("ADMIN_EMAIL","");
  addDefaultConfig("ADMIN_EMAILNOTIFICATION","NEIN");

  addDefaultConfig("FILES_PER_PAGE","10");
  addDefaultConfig("STATS_RSS","NEIN");
  addDefaultConfig("STATS_MP3","NEIN");
  addDefaultConfig("WEBSPACE_LIMIT","0");
  addDefaultConfig("LOKAL_PERL","TRUE");
  addDefaultConfig("UPLOADRELAIS_MODE","auto");
  addDefaultConfig("UPLOADRELAIS_UP_ADRESS","");
  addDefaultConfig("UPLOADRELAIS_DOWN_ADRESS","");

  addDefaultConfig("LAYOUT_ID","std");
  addDefaultConfig("STDLAYOUT_MP3FLASHPLAYER","JA");

  // ----

  ############ AUTO-UPDATES ##########################################

  // ---- UPDATE Konfiguration aus podblogger 0.3 und darunter
  // ---------------------------------------------------------
  // lodConfig.php kmmert sich nur darum die Konfigurationsdatei
  // selbststndig auf den neusten Stand zu bringen
  // alle anderen Update-nderungen im System bernimmt
  // installcheck.php (wird automatisch bei einem Update aufgerufen)

  // PRFEN, OB ALTE KONFIGURATION BER "config.txt.php" EXISTIERT

  if (file_exists("config.txt.php"))
  {
    if (!file_exists(CONFIGFILE_PATH."config.txt"))
    {

      // Schreibrechte in 'CONFIGFILE_PATH' prfen
      if (!checkDir(CONFIGFILE_PATH))
      {
        print "<strong>PROBLEM:</strong><br>podblogger konnte nicht mit der Installation beginnen, da das Verzeichnis '".CONFIGFILE_PATH."' im podblogger-Verzeichnis auf dem Webserver scheinbar keine Schreibrechte besitzt. ".
              "Bitte versuchen Sie diese Schreibrechte (chmod 777) manuell z.B. mit einem FTP-Programm zu setzten.";

        print "<br><br>Mehr Informationen zum Setzten von Schreibrechten unter:<br>";
        print "<a href='http://www.pc-special.net/?idcat=73' target='_blank'>http://www.pc-special.net/?idcat=73</a><br><br>";

        exit();
      }

      // Werte aus alter Config-Datei laden
      require("config.txt.php");

      // Neue Konfiguration anlegen
      $config_object = new ConfigTool();
      $config_object->setIndent( 30 );
      $config_object->setFileName(CONFIGFILE_PATH."config.txt" );

      // geladene Werte (soweit vorhanden) in neuer Config-Datei bertragen
      savePHPvar($config_object, "PODCAST_NAME", 				"PODCAST_NAME", 			getDefault("PODCAST_NAME"));
      savePHPvar($config_object, "PODBLOGGER_VERSION", 			"PODBLOGGER_VERSION", 		"0.3");
      savePHPvar($config_object, "PODBLOGGER_STATUS", 			"PODBLOGGER_STATUS", 		"UPDATE");

      savePHPvar($config_object, "PODCAST_DESCRIPTION", 		"PODCAST_BESCHREIBUNG", 	getDefault("PODCAST_DESCRIPTION"));
      savePHPvar($config_object, "PODCAST_CATEGORY", 			"PODCAST_KATEGORIEN", 		getDefault("PODCAST_CATEGORY"));

      savePHPvar($config_object, "ADMIN_PASSWORD", 				"ADMIN_PASSWORD", 			getDefault("ADMIN_PASSWORD"));
      savePHPvar($config_object, "ADMIN_NAME", 					"ADMIN_NAME", 				getDefault("ADMIN_NAME"));
      savePHPvar($config_object, "ADMIN_EMAIL", 				"ADMIN_EMAIL", 				getDefault("ADMIN_EMAIL"));
      savePHPvar($config_object, "ADMIN_EMAILNOTIFICATION", 	"EMAIL_BENACHRICHTIGUNG", 	getDefault("ADMIN_EMAILNOTIFICATION"));

      savePHPvar($config_object, "FILES_PER_PAGE", 				"DATEIEN_PRO_SEITE", 		getDefault("FILES_PER_PAGE"));
      savePHPvar($config_object, "STATS_RSS", 					"PODCAST_RSS_STATS", 		getDefault("STATS_RSS"));
      savePHPvar($config_object, "STATS_MP3", 					"PODCAST_MP3_STATS", 		getDefault("STATS_MP3"));
      savePHPvar($config_object, "WEBSPACE_LIMIT", 				"WEBSPACE_LIMIT", 			getDefault("WEBSPACE_LIMIT"));
      savePHPvar($config_object, "UPLOADRELAIS_MODE", 			"UPLOAD_MODE", 				"man" );
      savePHPvar($config_object, "UPLOADRELAIS_UP_ADRESS", 		"UPLOAD_CGI_SCRIPT", 		getDefault("UPLOADRELAIS_UP_ADRESS"));
      savePHPvar($config_object, "UPLOADRELAIS_DOWN_ADRESS", 	"DOWNLOAD_CGI_SCRIPT", 		getDefault("UPLOADRELAIS_DOWN_ADRESS"));

      savePHPvar($config_object, "STDLAYOUT_MP3FLASHPLAYER", 	"PODCAST_MP3FLASHPLAYER", 	getDefault("STDLAYOUT_MP3FLASHPLAYER"));


      // neue Config-Datei speichern
      $config_object->saveToFile();


      // Alte Config-Datei lschen
      if (!@unlink("config.txt.php"))
      {
        if (file_exists(CONFIGFILE_PATH."config.txt"))
        {
          print "PROBLEM: Neue Konfiguration konnte angelegt werden. Doch die alte Datei '/config.txt.php' lsst<br>".
                "sich nicht lschen. Bitte lschen Sie diese direkt auf dem Server. Ansonsten kann podblogger nicht sauber laufen.";
        }
        else
        {
          print "PROBLEM: podblogger kann nicht im Verzeichnis '".CONFIGFILE_PATH."' schreiben!".
                "Bitte setzten Sie ber ein FTP-Programm die Schreibrechte (chmod(777)).";

          print "<br><br>Mehr Informationen zum Setzten von Schreibrechten unter:<br>";
          print "<a href='http://www.pc-special.net/?idcat=73' target='_blank'>http://www.pc-special.net/?idcat=73</a><br><br>";
        }
        exit();
      }
    }
    else
    {
      print "PROBLEM: Es exitieren zwei Konfigurationsdateien!<br><br>".
            "- Die alte Konfiguration '/config.txt.php'<br>".
            "- Die neue Konfiguration '/".CONFIGFILE_PATH."config.txt'<br><br>".
            "Sie knnen das Problem lsen, indem Sie die alte Konfiguration auf dem Server lschen.<br>".
            "Doch damit gehen auch die darin enthaltenden Einstellungen verlohren.<br>";
      exit();
    }

  }

  // ---- ENDE UPDATE


  ############ CONFIG-DATEI BEI ERSTEM START ANLEGEN #################

  if (!file_exists(CONFIGFILE_PATH."config.txt"))
  {
    // Schreibrechte in 'CONFIGFILE_PATH' prfen
    if (!checkDir(CONFIGFILE_PATH))
    {
      print "<strong>PROBLEM:</strong><br>podblogger konnte nicht mit der Installation beginnen, da das Verzeichnis '".CONFIGFILE_PATH."' im podblogger-Verzeichnis auf dem Webserver scheinbar keine Schreibrechte besitzt. ".
            "Bitte versuchen Sie diese Schreibrechte (chmod 777) manuell z.B. mit einem FTP-Programm zu setzten.";

      print "<br><br>Mehr Informationen zum Setzten von Schreibrechten unter:<br>";
      print "<a href='http://www.pc-special.net/?idcat=73' target='_blank'>http://www.pc-special.net/?idcat=73</a><br><br>";

      exit();
    }

    // Konfiguration anlegen
    $config_object = new ConfigTool();
    $config_object->setIndent( 30 );
    $config_object->setFileName(CONFIGFILE_PATH."config.txt" );

    // Werte aus dem defalut-Array in die ConfigDatei bertragen
    foreach ($defValues as $value)
    {
      initConfigValue($config_object, $value["key"], $value["value"]);
    }

    // Konfuguration-Datei speichern
    $config_object->saveToFile();

    // prfen, ob config.txt geschrieben wurde
    if (file_exists(CONFIGFILE_PATH."config.txt"))
    {
      // prfen, ob das Verzeichnis durch eine htaccess-Datei vor dem ffentlichen Zugriff geschtzt ist
      if (!file_exists(CONFIGFILE_PATH.".htaccess"))
      {
        if ($fp = @fopen(CONFIGFILE_PATH.".htaccess","w"))
        {
          fwrite($fp,"Order deny,allow\nDeny from all\n");
          fclose($fp);
        }
      }
    }
  }


  ############ CONFIG-DATEN LADEN ####################################

  // Werte werden aus der Configdatei in globale PHP-Variablen geladen

  $config_object = new ConfigTool();
  $config_object->setConfigFromFile(CONFIGFILE_PATH."config.txt");

  // Alle im DefaultArray-Eingetragene Key-Werte automatisch aus der Config-Datei laden
  // und als GLOBAL-Variable eintragen
  foreach ($defValues as $value)
  {
    $GLOBALS[$value['key']] = getValue($config_object, $value['key']);
  }

  // Folgender Schritt fllt einem noch ausstehenden Refactoring zu grunde:
  $PODCAST_BESCHREIBUNG     = $PODCAST_DESCRIPTION;
  $PODCAST_KATEGORIEN       = $PODCAST_CATEGORY;
  $EMAIL_BENACHRICHTIGUNG   = $ADMIN_EMAILNOTIFICATION;
  $DATEIEN_PRO_SEITE        = $FILES_PER_PAGE;
  $PODCAST_RSS_STATS        = $STATS_RSS;
  $PODCAST_MP3_STATS        = $STATS_MP3;
  $UPLOAD_CGI_SCRIPT        = $UPLOADRELAIS_UP_ADRESS;
  $DOWNLOAD_CGI_SCRIPT      = $UPLOADRELAIS_DOWN_ADRESS;
  $PODCAST_MP3FLASHPLAYER   = $STDLAYOUT_MP3FLASHPLAYER;

  // Nun sind alle ntigen Konfigurationswerte geladen


  ############ PRFEN OB UPDATE ODER INSTALL VORLIEGT ################

  // ---- UPDATE Konfiguration podblogger 0.4 und hher ------
  // ---------------------------------------------------------

  // Die Variable PODBLOGGER_VERSION wird gecheckt
  // Liegt der Wert unter dem Defaultwert liegt ein Updatefall vor

  if  ( doubleval($PODBLOGGER_VERSION) < (getDefault('PODBLOGGER_VERSION')) )
  {
     $PODBLOGGER_STATUS = "UPDATE";
     updateValueInConfigFile("PODBLOGGER_STATUS");

    $PODBLOGGER_NEXTSTEP = "INSTALLCHECK_START";
    updateValueInConfigFile("PODBLOGGER_NEXTSTEP");
  }

  // Wenn ein Update oder Install vorliegt, wird automatisch
  // auf installcheck umgeleitet

  if ( (!isset($GLOBALS['installcheck'])) && ($PODBLOGGER_NEXTSTEP == "INSTALLCHECK_START") )
  {

    $PODBLOGGER_NEXTSTEP = "INSTALLCHECK_FIRST";
    updateValueInConfigFile("PODBLOGGER_NEXTSTEP");



    // Weiterleitung zum Installcheck (installcheck.php)
    ?>
    <html>
    <head>
    <? print '<meta http-equiv="refresh" content="0; URL=installcheck.php">'; ?>
    <title>...</title>
    </head>
    <body><br>
    <center>
    <? print '<a href="installcheck.php">'; ?>
    click ...</a></center>
    </body>
    </html>
    <?
    exit();
  }

  // #### ENDE INIT-WORK #############################################

  // ----------------------------------------------------------------------------------------------

  ####################################################################
  # EIGENE KONFIGURATIONFUNKTIONEN
  ####################################################################
  #
  # Folgende Funktionen werden zum Arbeiten mit der Klasse ConfigTool
  # bentigt.
  #
  ####################################################################

  // ---- prfen, ob Config-Wert gesetzt wurde
  // return : BOOLEAN
  function config_isset (&$config_object, $valueName)
  {
    //$testLoad = $config_object->get($valueName);
    //if ($testLoad == "undefined")
    if (!$config_object->isDefined($valueName))
    {return FALSE;}
    else
    { return TRUE;}
  }

  // ---- Configwert anlegen, wenn er noch nicht im ConfigFile gesetzt wurde
  // return: VOID
  function initConfigValue(&$config_object, $valueName, $value)
  {
    if (!config_isset($config_object, $valueName))
    {
      $value = serialize($value);
      $config_object->addKeyValue( $valueName, urlencode($value));
    }
  }

  // ---- Configwert anlegen, wenn er noch nicht im ConfigFile gesetzt wurde
  // return: VOID
  function updateConfigValue(&$config_object, $valueName, $value)
  {
    if (config_isset($config_object, $valueName))
    {
      $value = serialize($value);
      $config_object->updateKeyValue( $valueName, urlencode($value));
    }
  }

  // ---- Speichert PHP-Variable in ConfifFile
  // ---- schreibt den Wert der PHP-Variable in den ConfigFile, wenn dort noch kein Eintrag fr diese existiert
  // ---- ist PHP-Variable nicht gesetzt, wird der Defaultwert gesetzt
  function savePHPvar(&$config_object, $valueName, $phpVar, $defaultValue)
  {
    // prfen, ob PHP-Variable gesetzt wurde
    if (isset($GLOBALS[$phpVar]))
    { $toSaveValue = $GLOBALS[$phpVar]; }
    else
    { $toSaveValue = $defaultValue;}

    // ConfigWert speichern
    initConfigValue($config_object, $valueName, $toSaveValue);
  }

  function getValue(&$config_object, $valueName)
  {
    if (config_isset($config_object, $valueName))
    {
      $value = $config_object->get($valueName);
      // if (strlen($value) > 1) 	{return unserialize(urldecode($value));}
      return unserialize(urldecode($value));
    }
    else
    {
      // Variable ist noch nicht in der Configdatei vorhanden
      // prfen, ob hierzu ein Defaultwert im Default-Array existiert
      {

        foreach ($GLOBALS['defValues'] as $value)
        {
          if ($value["key"] == $valueName)
          {
            // Default-Wert gefunden. Diesen in die Configdatei eintragen
            $config_object->setIndent( 30 );
            initConfigValue($config_object, $value["key"], $value["value"]);
            // Konfuguration-Datei speichern
            $config_object->saveToFile();
            return $value["value"];
          }
        }

        // Falls nicht gefunden
        exit("Der Wert '".$valueName."' existiert nicht als Config-Vaule!! Weder in der Configdatei ... noch als Defaultwert.");

      }
    }
  }

  // --- Wird in anderen Scripten genutzt, um einen Wert zu aktualisieren
  function updateValueInConfigFile($key)
  {
    $value = $GLOBALS[$key];
    $conf = new ConfigTool();
    $conf->setConfigFromFile(CONFIGFILE_PATH."config.txt");
    if (config_isset($conf, $key))
    {
      $value = serialize($value);
      $conf->updateKeyValue( $key, urlencode($value));
      $conf->saveToFile();
    }
    else
    {
      die("FEHLER: Config-Wert '".$key."' existiert nicht in config.txt.");
    }
  }

  // --- Fgt einen Wert dem Default-Array hinzu
  function addDefaultConfig($key, $value)
  {
    array_push($GLOBALS['defValues'],array("key" => $key, "value" => $value));
  }

  // Gibt den passenden Wert als dem Default-Array zurck
  function getDefault ($key)
  {
    foreach ($GLOBALS['defValues'] as $defPair)
    {
      if ($defPair['key'] == $key)
      { return $defPair['value']; }
    }
    return FALSE;
  }

  // Testet ob die Schreibrechte fr ein Verzeichnis gesetzt ist
  function checkDir($verzeichnispfad)
  {
    if ($fp = @fopen($verzeichnispfad."test.tst","w"))
    {
      // Testdatei schreiben / lesen / lschen
      fwrite($fp,"TEST");
      fclose($fp);
      $fp = @fopen($verzeichnispfad."test.tst","r");
      $text = @fread($fp,1024);
      @fclose($fp);
      @unlink($verzeichnispfad."test.tst");

      // Test auswerten
      if ($text == "TEST")
      { return TRUE; }

    }
    // Wenn Test nicht positiv war
    return FALSE;
  }
?>