<?
  #################################################
  # podblogger 0.4                                #
  # by Christian Rotzoll                          #
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #                                               #
  #################################################
  # INDEX-Script                                  #
  #################################################

  #############################################################################################################
  # Dieses Script hat die Aufgabe die HTML-HAUPTSEITE von podblogger auszugeben.
  # Es bereitet die Daten gem den Benutzerinteraktionen auf und reicht diese dann an die
  # SMARTY-TEMPLATE-ENGINE weiter, die fr das Layout eines podblogger-Systems zustndig ist.
  #
  # Um das Layout von podblogger zu ndern, bitte die Datei 'std_index.tpl' im Verzeichnis
  # 'htmlContent/smarty_templates' bearbeiten.
  #############################################################################################################

  require_once ("include/funktions_sammlung.inc.php");
  require_once ("include/article.class.php");
  require_once ("include/layout.class.php");
  require_once ('include/smarty/Smarty.class.php');
  require_once ('include/bbcode.inc.php');

  // Prfen, ob das Podbloggersystem nach einem Install oder Update lauffhig ist
  if ($PODBLOGGER_STATUS != "READY")
  {
    // Das System muss noch oder wird gerade vom ADMIN eingerichtet (werden).
    print "<html><body><center><strong>".
          "Die Seite wird gerade vom Administrator berarbeitet.<br>".
          "Bitte probieren Sie es zu einem spteren Zeitpunkt erneut.<br>".
          "DANKE fr Ihr Verstndnis.<br><br><font size='-1'><a href='installcheck.php'>ADMIN</a></font>".
          "</strong></center></body></html>";
    exit();
  } // ENDE berprfung Lauffhigkeit

  // Parameter bernehmen
  if (issetPostGet('seite')) {$seite = getPostGetText('seite');}
  else {$seite = "";}
  
  if (issetPostGet('cat')) {$cat = getPostGetText('cat');}
  
  if (issetPostGet('weiterbei')) {$weiterbei = getPostGetInt('weiterbei');}
  else {$weiterbei = 1;}


  // SMARTY Template-Datenobjekt anlegen und konfigurieren
  $smarty = new Smarty;

  $smarty->template_dir = LAYOUTDIR;
  $smarty->compile_dir = SMARTYPATH_COMPILE;
  $smarty->config_dir = SMARTYPATH_CONFIG;
  $smarty->cache_dir = SMARTYPATH_CACHE;

  $smarty->assign('PODCAST_sitename',$PODCAST_NAME);
  $smarty->assign('PODCAST_admin_name',$ADMIN_NAME);
  $smarty->assign('PODCAST_admin_mail',$ADMIN_EMAIL);
  $smarty->assign('PODCAST_httpbaseadress',"http://".HTTP_BASISADRESSE);
  $smarty->assign('PODCAST_kategorien_array',$PODCAST_KATEGORIEN);
  $smarty->assign('PODCAST_category_array',$PODCAST_KATEGORIEN);  
  
  if (isset($cat))
  {
    $smarty->assign('PODCAST_category',$cat);
  }
  else
  {
    $smarty->assign('PODCAST_category',"");  
  }

  if (strlen("http://".HTTP_BASISADRESSE."rss.php") < 50)
  {
    $smarty->assign('PODCAST_rssfeedtextadress',"http://".HTTP_BASISADRESSE."rss.php");
  }
  else
  {
    $smarty->assign('PODCAST_rssfeedtextadress',"");
  }

  $smarty->assign('podblogger_version',$PODBLOGGER_VERSION);

  // Headerinformationen, die ein cachen der Seite verhindern
  header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
  header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
  header("Cache-Control: no-store, no-cache, must-revalidate");
  header("Cache-Control: post-check=0, pre-check=0", false);
  header("Pragma: no-cache");

  // Bei erstem Start installcheck starten
  if (!file_exists("uploadData/.htaccess"))
  {
   // Dies ist eine technische Umleitung per HTML-redirect
   // keine smarty-Formatierung notwendig.
   ?>
        <html><head>
        <meta http-equiv="refresh" content="0; URL=installcheck.php?grund=ersterStart">
        <title>Weiterleitung ...</title>
        </head><body><br><center>
        <a href='installcheck.php?grund=ersterStart'>
        Klick hier ...</a></center>
        </body></html>
   <?
   exit();
  }

  if ($seite == "")
  {

     // Alle vorhandenen Dateien suchen
     $articles = getFilesFromDirWithEnding("publicData","article");

     // Array mit Keys aufbauen
     $keyArray = array();
     foreach ($articles as $articleFile)
     {
       $artikel = article::loadArticleFromFile("publicData/".$articleFile);
       if (($artikel!=FALSE) && ($artikel->checkValid()))
       {
         if (!isset($cat))
         {
           $keyArray[$artikel->getUnixTime()] = $artikel;
         }
         else
         {
           if ($artikel->getCategory() == $cat)
           {
             $keyArray[$artikel->getUnixTime()] = $artikel;             
           }
         }  
       }
     }

     uksort($keyArray,"cmp");
     reset($keyArray);

     $output_beitraege = array();

     if (count($keyArray) > ($weiterbei-1))
     {
       $ccount=1;

       foreach ($keyArray as $artikel)
       {
         $mp3Beitrag = array();

         if (($ccount >= $weiterbei) && ($ccount < ($weiterbei+$DATEIEN_PRO_SEITE)))
         {
           $mp3Beitrag['titel']        = $artikel->getTitle();
           $mp3Beitrag['kategorie']    = $artikel->getCategory();
           $mp3Beitrag['beschreibung'] = bbcode_inc::renderBBCode($artikel->getDescription());
           $mp3Beitrag['autor_name']   = $artikel->getAuthorName();
           $mp3Beitrag['autor_mail']   = $artikel->getAuthorMail();
           $mp3Beitrag['zeit']         = date("d.m.y",$artikel->getUnixTime());
           $mp3Beitrag['zeit_int']     = $artikel->getUnixTime();

           // ggf. der Satistik wegen den Zugriff auf die MP3-dateien ber das getMedia.php leiten
           if ($PODCAST_MP3_STATS == "JA")
           {
             $mp3Beitrag['link'] = "getMedia.php?from=BROWSER&file=publicData/".$artikel->getFile();
             $playerLink = "publicData/".$artikel->getFile();
           }
           else
           {
             $mp3Beitrag['link'] = "publicData/".$artikel->getFile();
             $playerLink = $mp3Beitrag['link'];
           }


           if ($PODCAST_MP3FLASHPLAYER == "JA")
           {
             $mp3Beitrag['audioplayer_code'] = '
             <object type="application/x-shockwave-flash" data="htmlContent/emff_player/emff_mod2.swf?src='.$playerLink.'&callback='.HTTP_BASISADRESSE.'" width="55" height="25">
               <param name="movie" value="htmlContent/emff_player/emff_mod2.swf?src='.$playerLink.'&callback='.HTTP_BASISADRESSE.'">
               <param name="quality" value="high">
               <param name="wmode" value="transparent">
               <!-- Alternative falls kein Flash vorhanden -->
                 <a href="'.$mp3Beitrag['link'].'"><img border=0 src="hmtlContent/grafiken/mp3.gif"></a>
               <!-- Alternative ENDE -->
             </object>';
           }
           else
           {
             $mp3Beitrag['audioplayer_code'] = '';
           }


           $size = round(filesize("publicData/".$artikel->getFile()) / 1048576);
           if ($size == 0) {$size = 1;}
           $mp3Beitrag['dateigroesse']      = $size;

           array_push($output_beitraege,$mp3Beitrag);
         }
         $ccount++;
       }
       $smarty->assign('PODCAST_item_count',$ccount);
       $smarty->assign('PODCAST_item_array',$output_beitraege);


       if ( $weiterbei > $DATEIEN_PRO_SEITE )
       {
         $smarty->assign('PODCAST_backlink','index.php?weiterbei='.($weiterbei-$DATEIEN_PRO_SEITE));
       }
       else
       {
         $smarty->assign('PODCAST_backlink','off');
       }
       if ( count($keyArray) >= ($weiterbei+$DATEIEN_PRO_SEITE) )
       {
         $smarty->assign('PODCAST_forwardlink','index.php?weiterbei='.($weiterbei+$DATEIEN_PRO_SEITE));
       }
       else
       {
         $smarty->assign('PODCAST_forwardlink','off');
       }
     }
     else
     {
       $smarty->assign('PODCAST_item_count',0);
       $smarty->assign('PODCAST_backlink','off');
       $smarty->assign('PODCAST_forwardlink','off');
     }

    // Layout Datenfelder laden
    $o_layout = layout::loadLayoutFromPluginDir($LAYOUT_ID);
    $defs =  $o_layout->getDefinitionArray();
    //exit(serialize($defs));
    foreach ($defs as $def)
    {
      if (isset($def['value'])) { $smarty->assign($def['smartyname'],$def['value']); }
      else						{ $smarty->assign($def['smartyname'],""); }
    }

    $smarty->display($LAYOUT_ID.'/index.tpl');
  }
  else // $seite-ELSE
  {
    $smarty->display($seite);
  }
?>