<?
  #################################################
  # podblogger 0.4.3                              #
  # by Christian Rotzoll                          #
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #                                               #
  #################################################
  # RSS-FEED-Generator                            #
  #################################################

  require("include/funktions_sammlung.inc.php");
  require("include/bbcode.inc.php");
  require("include/LogFile.class.php");
  require("include/article.class.php");

  function is_client_iTunes()
  {
    $client = getenv('HTTP_USER_AGENT');
    if (stristr($client,"iTunes"))
    {return TRUE;}
    else
    {return FALSE;}
  }

  // Prfen, ob das Podbloggersystem nach einem Install oder Update lauffhig ist
  if ($PODBLOGGER_STATUS != "READY")
  {
    // Auf RSS kann bis Install oder Update abgeschlossen ist nicht zugegriffen werden
    header("HTTP/1.0 404 Not Found");

    exit();
  } // ENDE berprfung Lauffhigkeit


  if (issetPostGet('kategorie'))
  {
    $kategorie = getPostGetText('kategorie');
    $titelzusatz = " - ".$kategorie;
  }
  else
  {
    $kategorie = "";
    $titelzusatz = "";
  }

  if ($PODCAST_RSS_STATS == "JA")
  {
    $client = getenv('HTTP_USER_AGENT');
    LogFile::writeLog("RSS/".$kategorie, $client, "RSS");
  }

$DatsInFeed = 5;

header ('Content-Type: application/xml; charset=UTF-8',TRUE);

print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>";
print "<rss version=\"2.0\">\n";
print "<channel>\n";
print "<title>".sonderzeichenWandeln(strip_tags($PODCAST_NAME)).$titelzusatz."</title>\n";
print "<link>http://".HTTP_BASISADRESSE."</link>\n";
print "<description>".sonderzeichenWandeln(strip_tags(stripslashes($PODCAST_BESCHREIBUNG)))."</description>\n";
print "<lastBuildDate>" . date("r") ."</lastBuildDate>\n";
print "<language>de</language>\n";
print "<copyright>for licence see http://".HTTP_BASISADRESSE."</copyright>\n";
print "<generator>podblogger v0.4</generator>\n";

// wenn ein bild fr das RSS vorhanden ist, dann werden die entsprechenden Tags eingebaut
$image = "";
if (file_exists("rsspic.gif")) 
{$image = "rsspic.gif";}
elseif (file_exists("rsspic.jpg")) 
{$image = "rsspic.jpg";}
if ($image!="")
{
print '<image>'."\n";
print '  <url>http://'.HTTP_BASISADRESSE.$image.'</url>'."\n";
print '  <title>'.sonderzeichenWandeln(strip_tags($PODCAST_NAME)).$titelzusatz.'</title>'."\n";
print '  <link>http://'.HTTP_BASISADRESSE.'index.php</link>'."\n";
print '</image>'."\n";
}

if (strlen($ADMIN_EMAIL) > 6) print "<managingEditor>".$ADMIN_EMAIL."</managingEditor>";
print "<ttl>60</ttl>\n\n";

// alle ffentlichen Artikel suchen
$Dateien = getFilesFromDirWithEnding("publicData","article");

// nach Zeit sortieren
$keyArray = array();
foreach ($Dateien as $datei)
{

  $artikel = article::loadArticleFromFile("publicData/".$datei);

  // Nur Artikel ins RSS aufnehmen, deren Kategorie nicht mit "!" anfngt
  $kat = $artikel->getCategory();
  if ($kat[0] != '!')
  {
    if ($kategorie!="")
    {
      if ($kategorie == $artikel->getCategory())
      {$keyArray[$artikel->getUnixTime()] = $artikel;}
    }
    else
    {  $keyArray[$artikel->getUnixTime()] = $artikel; }
  }

}
arsort($keyArray);
reset($keyArray);

// Bei der Ausgabe werden entweder die letzten $DatsInFeed - Dateien ausgegeben ...
// oder die Dateien der letzten 7 Tage

foreach ($keyArray as $artikel)
{
  // prfen ob die Datei nicht lter als 7 Tage ist
  $diffTime = time() - $artikel->getUnixTime();
  $tage     = round($diffTime / (60*60*24));

  // ggf. den Link auf die MP3-Datei ber das getMediaScript leiten
   if ($PODCAST_MP3_STATS == "JA")
   {
     if (is_client_iTunes())
     {
       // solange iTunes hat Probleme mit der Statistikfunktion ...
       $mp3Link = "http://".HTTP_BASISADRESSE."publicData/".$artikel->getFile();     
     }
     else
     {
       $mp3Link = "http://".HTTP_BASISADRESSE."getMedia.php?file=publicData/".$artikel->getFile();
     }  
   }
   else
   {
     $mp3Link = "http://".HTTP_BASISADRESSE."publicData/".$artikel->getFile();
   }

  if (($DatsInFeed > 0) || ($tage <= 7))
  {
    print ("<item>\n");
    print ("<title>".sonderzeichenWandeln($artikel->getCategory())." - ".sonderzeichenWandeln(strip_tags($artikel->getTitle()))."</title>\n");
    print ("<link>http://".HTTP_BASISADRESSE. "publicData/" .$artikel->getFile()."</link>\n");
    print ("<category>".sonderzeichenWandeln($artikel->getCategory())."</category>");
    print ("<description>".strip_tags(sonderzeichenWandeln($artikel->getDescription()))."</description>\n");
    print ("<pubDate>".date("r",$artikel->getUnixTime())."</pubDate>\n");
    print ("<enclosure url=\"".$mp3Link."\" length=\"");
    print filesize("publicData/".$artikel->getFile());
    print ("\" type=\"audio/mpeg\"/>\n");
    print ("</item>\n\n");
    $DatsInFeed--;
  }
}

/*
for ($i=$DatsInFeed; $i>0; $i--)
{
  if (count($keyArray) > 0)
  {
    $infData = array_pop($keyArray);
    print ("<item>\n");
    print ("<title>".sonderzeichenWandeln($infData[KATEGORIE])." - ".sonderzeichenWandeln(strip_tags(stripslashes($infData[TITEL])))."</title>\n");
    print ("<link>http://".HTTP_BASISADRESSE. "publicData/" .$infData[DATEINAME]."</link>\n");
    print ("<category>".sonderzeichenWandeln($infData[KATEGORIE])."</category>");
    print ("<description>".strip_tags(sonderzeichenWandeln(stripslashes($infData[BESCHREIBUNG])))."</description>\n");
    print ("<pubDate>".date("r",$infData[ZEIT])."</pubDate>\n");
    print ("<enclosure url=\"http://".HTTP_BASISADRESSE. "publicData/" .$infData[DATEINAME] ."\" length=\"");
    print filesize("publicData/".$infData[DATEINAME]);
    print ("\" type=\"audio/mpeg\"/>\n");
    print ("</item>\n\n");
  }
}
*/

print "</channel>\n</rss>\n";
?>