<?
  #################################################
  # podblogger 0.4                                #
  # by Christian Rotzoll                          #
  #                                               #
  # christian.rotzoll@medien.uni-weimar.de        #
  # Doku unter http://www.rotzoll.de/podblogger   #
  #                                               #
  #################################################
  # DATEIUPLOAD-Script                            #
  #################################################

  require("include/funktions_sammlung.inc.php");
  require('include/smarty/Smarty.class.php');
  require('include/layout.class.php');
  require('include/ID3v1x.class.php');
  require('include/article.class.php');

  // SMARTY Template-Datenobjekt anlegen und konfigurieren
  $smarty = new Smarty;

  $smarty->template_dir = LAYOUTDIR;
  $smarty->compile_dir = SMARTYPATH_COMPILE;
  $smarty->config_dir = SMARTYPATH_CONFIG;
  $smarty->cache_dir = SMARTYPATH_CACHE;

  $smarty->assign('PODCAST_sitename',$PODCAST_NAME);

  // ------ Step Init ------------------------
  if (issetPostGet('step'))
  {
    $step = getPostGetInt('step');
  }
  else
  {
    if (issetPostGet('uploadid'))
    {$step = 2;}
    else
    {$step = 1;}
  }

  if (issetPostGet('phpupload'))
  {$phpupload = 1;}
  else
  {$phpupload = 0;}

  session_start();
  if (!isset($_SESSION['admin']))
  { $_SESSION['admin'] = "notADMIN"; }

  // --------------------------------------------
  // ------ UPLOAD:SCHRITT 1 --------------------
  // --------------------------------------------

  // Hier wird das Start-Formular ausgegeben, in dem die
  // Medien-Datei ausgewhlt wird, die in das System geladen
  // soll.

  if ($step == 1)
  {

  // Headerinformationen, die ein cachen der Seite verhindern
  header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
  header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
  header("Cache-Control: no-store, no-cache, must-revalidate");
  header("Cache-Control: post-check=0, pre-check=0", false);
  header("Pragma: no-cache");

  // --------------------------------------------
  // ------ Fehlerhafte Uploads lschen ---------
  // --------------------------------------------

    // Eine Goodliste mit allen im Verzeichnis erlaubten Dateien erstellen
    $goodlist = array(".htaccess");
    $artcle_files = getFilesFromDirWithEnding("uploadData","article");
    foreach ($artcle_files as $artikel_file)
    {
      if($artikel = article::loadArticleFromFile("uploadData/".$artikel_file))
      {
        // Den Artikeleintrag und seine Datei schtzen, wenn ...
        // 1. erst ist gltig (abgeschlossener Upload)
        // 2. erst noch jnger als 6 Stunden

        // Alter des Artikels berechnen (in Sekunden)
        $ageOfArticle = time() - $artikel->getUnixTime();

        // 6 Stunden in Sekunden
        $deadline = 6 * 60 * 60;

        // Wenn eine der beiden Bedingung erfllt ist ...
        if (($artikel->checkValid()) || ($ageOfArticle < $deadline))
        {
          array_push($goodlist, $artikel_file);
          array_push($goodlist, $artikel->getFile());
        }
      }
    }

    // 2. alle Dateien, die nicht auf der Goodlist stehen lschen
    $verzeichnis = opendir("uploadData");
    while ($datei = readdir($verzeichnis))
    {
      // Wenn nicht in der goodliste vorhanden ...
      if (!my_search_stringArray($datei, $goodlist))
      {
        if (! is_Dir("uploadData/".$datei) ) {@unlink("uploadData/".$datei);}
      }
    }
    closedir($verzeichnis);

  // --------------------------------------------
  // ------ SPEICHERPLATZ BERPRFEN ------------
  // --------------------------------------------

  // Genereller Speicherplatz auf Server
  if ($freeByte = diskfreespace("uploadData"))
  {
    $freeMByte = round($freeByte / (1024 * 1024));

    if ($freeMByte < 5)
    {
      if ($EMAIL_BENACHRICHTIGUNG == "JA")
      {
        @mail($ADMIN_EMAIL, "podblogger-Meldung: Problem".$PODCAST_NAME, "Der verfgbare Webspace auf '".HTTP_BASISADRESSE."' ist unter 5MB. Es wird zwangslaufig zu Problemen kommen.\n\nDies ist eine automatische Benachrichtigung.");
      }
    }
  }

  // Speicherplatz Limits
  if ($WEBSPACE_LIMIT != 0)
  {
    $verbraucht = getUsedWebspace();
    if ($verbraucht >= $WEBSPACE_LIMIT)
    {
      fehlerMeldung ("<strong>PROBLEM: Es ist kein weiterer Speicherplatz fr Dateien freigegeben.</strong><br>(@ADMIN: Entweder WEBSPACE_LIMIT erhhen oder alte Dateien lschen.)");
    }
    elseif ((($verbraucht+10) > $WEBSPACE_LIMIT) && ($EMAIL_BENACHRICHTIGUNG == "JA"))
    {
        @mail($ADMIN_EMAIL, "podblogger-Meldung: Problem".$PODCAST_NAME, "Das Webspacelimit auf '".HTTP_BASISADRESSE."' ist bis auf 10MB erreicht. Es werden zwangslaufig keine Uploads mehr mglich sein.\n\nDies ist eine automatische Benachrichtigung.");
    }
  }

  // --------------------------------------------
  // ------ PRFEN, OB CGI-UPLOAD READY ---------
  // --------------------------------------------

  $CGIUPLOAD = FALSE;
  $hinweis = "";

  if ($UPLOADRELAIS_MODE!="off")
  {
      if ($fp = @fopen($UPLOAD_CGI_SCRIPT."?callback_script=status","r"))
      {
        $antwort = fread($fp,2048);
        fclose($fp);

        $data = explode("\n",$antwort);

        if (strstr($data[0],"TRAFFICLIMIT"))
        {
          // Upload-Traffic wurde berschritten
          $tage = $data[1];
          $hinweis = "Diese Funktion ist momentan nicht voll einsatzf&auml;hig. Es kann daher beim Upload von groen Dateien zu Problemen kommen.<br>".
                     "(Upload-Trafficlimit auf CGI-Upload-Relais ist momentan berschritten. Uneingeschrnkter Upload wieder in ".$tage." Tag(en) m&ouml;glich.)";
        }
        else if ($data[1]=="GO!")
        {
         $CGIUPLOAD = TRUE;
        }
      }
  }

  // --------------------------------------------
  // ------ SMARTY-Datenfelder bestimmen --------
  // --------------------------------------------

     if ($CGIUPLOAD)
     {
       // upload ber CGI-Upload-Relais
       $smarty->assign('PODCAST_uploadscript',$UPLOAD_CGI_SCRIPT);
       $smarty->assign('PODCAST_ImportantFormValues','<input type="hidden" name="callback_script" value="'.$PHP_CALLBACK_SCRIPT.'">');
     }
     else
     {
       // PHP-Upload
       $smarty->assign('PODCAST_uploadscript',"upload.php");
       $smarty->assign('PODCAST_ImportantFormValues','<input type="hidden" name="phpupload" value="1"><input type="hidden" name="step" value="2">');
     }

    // ggf. Warnhinweise in $PODCAST_UploadSystemWarnings fr Template hinterlegen

    $UploadSystemWarnings = "";
    if ($hinweis!="") $UploadSystemWarnings = "<strong>Hinweis: </strong>".$hinweis."<br><br>";

    $verbraucht = getUsedWebspace();
    if ( ($WEBSPACE_LIMIT != 0) &&  (($verbraucht+(100*1024*1024)) > $WEBSPACE_LIMIT))
    {
      $UploadSystemWarnings .= "(Es k&ouml;nnen noch insgesamt ".round(($WEBSPACE_LIMIT - $verbraucht)/(1024*1024))."MB geladen werden.)<br><br>";
    }
    else
    {
      $UploadSystemWarnings .= "    <!-- verbrauchterWebspace/limit : ".round($verbraucht/(1024*1024))."/".round($WEBSPACE_LIMIT/(1024*1024))." -->";
    }

    $smarty->assign('PODCAST_UploadSystemWarnings',$UploadSystemWarnings);

    // Template-Seite ausgeben
    $smarty->display($LAYOUT_ID.'/upload_1.tpl');

  }

  // --------------------------------------------
  // ------ UPLOAD:SCHRITT 2 --------------------
  // --------------------------------------------

  // 1. Die Upload-Datei vom CGI-Script holen und local speichern
  // 2. Das Formular fr weitere Zusatzinformationen ber SMARTY ausgeben

  elseif ($step == 2)
  {

    if ($phpupload)
    {
      ####### PHP-UPLOAD ENTGEGEN NEHMEN ##################################

      $CGI_upload_name = $_FILES['file']['name'];

      // Dateiendung berprfen
      if (strtolower( getDateiEndung($_FILES['file']['name']) ) != "mp3")
      {
        fehlerMeldung ("<strong>PROBLEM: Es knnen nur MP3-Dateien in das System geladen werden.</strong><br>");
      }

      // Namen behandeln
      $CGI_upload_name = sonderzeichenInDateinameWandeln($CGI_upload_name);
      $CGI_upload_name = ggfDatumskennungHinzufuegen($CGI_upload_name);
      $CGI_upload_name = urlencode($CGI_upload_name);

      while (file_exists("uploadData/".$CGI_upload_name))
      {
        $CGI_upload_name = "_".$CGI_upload_name;
      }

      // Webspacelimit prfen
      if ( ($WEBSPACE_LIMIT != 0) && ((getUsedWebspace()+$_FILES['file']['size']) > $WEBSPACE_LIMIT) )
      {
        fehlerMeldung ("<strong>PROBLEM: Die Dateigre bersteigt den noch vorhandenen Speicherplatz auf dem Server!</strong><br>(@ADMIN: Entweder WEBSPACE_LIMIT erhhen oder alte Dateien lschen.)");
      }

      // Artikel-Datei anlegen, damit die kommende MP3-Datei durch diese vor Lschung geschtzt ist
      $artikelID = article::createUniqueID();
      if (isset($CGI_upload_name))
      {
        $artikel = new article($artikelID);
        $artikel->setUnixTime(time());
        $artikel->setFile($CGI_upload_name);
        $artikel->save("uploadData");
      }

      // Datei kopieren (ggf. Fehler kommentieren)
      if (!move_uploaded_file($_FILES['file']['tmp_name'], "uploadData/" . $CGI_upload_name))
      {
        @unlink("uploadData/".$artikelID.".article");

        if ($_FILES['file']['error'] == 1)
        {
          fehlerMeldung ("<strong>PROBLEM: Die Datei ist fr PHP zu gro. Sie bersteigt das PHP-UPLOAD-LIMIT des Webservers!</strong><br>(@ADMIN: Entweder Uploadbegrenzung in php.ini erhhen oder ein CGI-Upload-Relais nutzen.)");
        }
        elseif ($_FILES['file']['error'] > 1)
        {
          fehlerMeldung ("<strong>PROBLEM: Der Upload war fehlerhaft!</strong><br>");
        }
        else
        {
          fehlerMeldung ("<strong>PROBLEM: Der Uploadvorgang ist fehlgeschlagen!</strong><br>(@ADMIN: Problem beim schreiben der Datei. Ggf. kein freiher Webspace mehr.)");
        }
      }
    }
    else
    {
      ####### UPLOAD von CGI-UPLOAD-RELAIS ENTGEGEN NEHMEN ################

      if (issetPostGet('uploadid'))
      {
        $CGI_upload_id = getPostGetInt('uploadid');

          // ---- Name der Uploaddatei vom CGI-Script holen
          if ($wp = fopen("$DOWNLOAD_CGI_SCRIPT?request=vorhanden&id=$CGI_upload_id","r"))
          {
            $upload_existiert = fread($wp,2048);
            fclose($wp);
            $upload_existiert = trim($upload_existiert);
          }
          else
          { die("\nFEHLER: Upload-VORHANDEN ("."$DOWNLOAD_CGI_SCRIPT?request=vorhanden&id=$CGI_upload_id".") auf CGI lt sich nicht ffnen.");}

          // Nur wenn der Download vorhanden ist -> herunterladen
          if ($upload_existiert == "TRUE")
          {

            // ---- Name der Uploaddatei vom CGI-Script holen
            if ($wp = fopen("$DOWNLOAD_CGI_SCRIPT?request=filename&id=$CGI_upload_id","r"))
            {
              $CGI_upload_name = fread($wp,2048);
              fclose($wp);
              $CGI_upload_name = trim($CGI_upload_name);

              $CGI_upload_name = sonderzeichenInDateinameWandeln($CGI_upload_name);
              $CGI_upload_name = ggfDatumskennungHinzufuegen($CGI_upload_name);

             $CGI_upload_name = urlencode($CGI_upload_name);
            }
            else
            { die("\nFEHLER: Upload-FILENAME ("."$DOWNLOAD_CGI_SCRIPT?request=filename&id=$CGI_upload_id".") auf CGI lt sich nicht ffnen.");
            }


            while (file_exists("uploadData/".$CGI_upload_name))
            {
              $CGI_upload_name = "_".$CGI_upload_name;
            }

            // Artikel-Datei anlegen, damit die kommende MP3-Datei durch diese vor Lschung geschtzt ist
            $artikelID = article::createUniqueID();
            if (isset($CGI_upload_name))
            {
              $artikel = new article($artikelID);
              $artikel->setUnixTime(time());
              $artikel->setFile($CGI_upload_name);
              $artikel->save("uploadData");
            }

            // ---- Daten der Uploaddatei vom CGI-Script holen und local speichern
            $bytecount = 0;
            if ($wp = fopen("$DOWNLOAD_CGI_SCRIPT?request=filedata&id=$CGI_upload_id","rb"))
            {
              if ($fp = fopen("uploadData/".$CGI_upload_name,"w+"))
              {
                while (!feof($wp))
                {
                  $data = fread($wp,2048);
                  $bytecount += strlen($data);
                  fwrite($fp,$data);
                }
                fclose($fp);
              }
              else
              { die("\nFEHLER: In Verzeichnis 'uploadData' koennen keine Dateien angelegt werden. Bitte Schreibrechte oder freien Webspace prfen.");}
              fclose($wp);
              if ($bytecount==0)
              { die("\nFEHLER: Es ist ein Fehler beim Upload aufgetreten. Datei = 0 Byte.<br>"."$DOWNLOAD_CGI_SCRIPT?request=filedata&id=$CGI_upload_id");}
            }
            else
            { die("\nFEHLER: Upload-DATA ("."$DOWNLOAD_CGI_SCRIPT?request=filename&id=$id".") auf CGI lt sich nicht ffnen.");}
          }  // end if $upload_existiert==TRUE

      }
      else
      {
        if (issetPostGet('filename'))
        {
          $CGI_upload_name = getPostGetText('filename');
        }
        else
        die("FEHLER: Das CGI-Upload-Script hat nicht den Parameter 'uploadid' uebergeben.");
      }

     } // end else !phpupload

      // prfen, ob Webspacelimit berschritten wurde
      if ( ($WEBSPACE_LIMIT != 0) &&  ((getUsedWebspace()) > $WEBSPACE_LIMIT))
      {
        @unlink("uploadData/".$CGI_upload_name);
        fehlerMeldung ("<strong>PROBLEM: Die Dateigre bersteigt den noch vorhandenen Speicherplatz auf dem Server!</strong><br>(@ADMIN: Entweder WEBSPACE_LIMIT erhhen oder alte Dateien lschen.)");
      }

      ####### PHP-Upload oder bzw. CGI-Upload fertig ##################################

      // Versuch aus der Datei Informationen zu gewinnen
      if ((isset($CGI_upload_name)) && ($mp3Inf = getMp3Info("uploadData/".$CGI_upload_name)))
      {
        $titel = $mp3Inf['Titel'];
        $autor = $mp3Inf['Kuenstler'];
        $beschreibung = $mp3Inf['Kommentar']. "(".$mp3Inf['Album']. " / " .$mp3Inf['Jahr']. ")";
      } // end if
      else
      {
        $titel = "";
        $autor = "";
        $beschreibung = "";
      } // else

    // --------------------------------------------
    // ------ SMARTY-Datenfelder bestimmen --------
    // --------------------------------------------

    $smarty->assign('PODCAST_uploadscript',$PHP_CALLBACK_SCRIPT);

    $smarty->assign('PODCAST_MP3_Titel',$titel);
    $smarty->assign('PODCAST_MP3_Beschreibung',$beschreibung);
    $smarty->assign('PODCAST_MP3_Autor',$autor);

    $smarty->assign('PODCAST_kategorien_array',$PODCAST_KATEGORIEN);

    $smarty->assign('PODCAST_ImportantFormValues','<input type="hidden" name="step" value="3"><input type="hidden" name="artikelID" value="'.$artikelID.'"><input type="hidden" name="filename" value="'.$CGI_upload_name.'">');

    // Template-Seite ausgeben
    $smarty->display($LAYOUT_ID.'/upload_2.tpl');

  } // end elseif step = 2

  // --------------------------------------------
  // ------ UPLOAD:SCHRITT 3 --------------------
  // --------------------------------------------

  // 1. Die Eingaben bernehmen und abspeichern
  // 2. E-Mail an Admin
  // 3. Besttigung ausgeben

  else if ($step == 3)
  {
    // ---- Parameter bernehmen
    if (issetPostGet('filename'))
    {$filename = getPostGetText('filename');}
    else { die("FEHLER: Es fehlen Parameter!");}
    $orgFilename = stripslashes($filename);
    $filename = strip_tags($filename);

    if (issetPostGet('artikelID'))
    {$artikelID = getPostGetText('artikelID');}
    else { die("FEHLER: Es fehlen Parameter!");}

    if (issetPostGet('titel'))
    {$titel = getPostGetText('titel');}
    else { die("FEHLER: Es fehlen Parameter!");}
    $titel = strip_tags($titel);

    if (issetPostGet('beschreibung'))
    {$beschreibung = getPostGetText('beschreibung');}
    else { die("FEHLER: Es fehlen Parameter!");}
    $beschreibung = strip_tags($beschreibung);
    $beschreibung = str_replace("\r\n","\n",$beschreibung);
    $beschreibung = str_replace("\n\r","\n",$beschreibung);

    if (issetPostGet('autor_name'))
    {$autor_name = getPostGetText('autor_name');}
    else { die("FEHLER: Es fehlen Parameter!");}
    $autor_name = strip_tags($autor_name);

    if (issetPostGet('autor_mail'))
    {$autor_mail = getPostGetText('autor_mail');}
    else { die("FEHLER: Es fehlen Parameter!");}
    $autor_mail = strip_tags($autor_mail);

    if (issetPostGet('autor_telefon'))
    {$autor_telefon = getPostGetText('autor_telefon');}
    else { die("FEHLER: Es fehlen Parameter!");}
    $autor_telefon = strip_tags($autor_telefon);

    if (issetPostGet('autor_bemerkung'))
    {$autor_bemerkung = getPostGetText('autor_bemerkung');}
    else { die("FEHLER: Es fehlen Parameter!");}
    $autor_bemerkung = strip_tags($autor_bemerkung);
    $autor_bemerkung = str_replace("\n","<br>",$autor_bemerkung);
    $autor_bemerkung = str_replace("\r","",$autor_bemerkung);

    if (issetPostGet('kategorie'))
    {$kategorie = getPostGetText('kategorie');}
    else { die("FEHLER: Es fehlen Parameter!");}



    if ($titel != "")
    {

        // Die Artikel-Datei erweitern
        if ($artikel = article::loadArticleFromFile("uploadData/".$artikelID.".article"))
        {
          $artikel->setTitle($titel);
          $artikel->setDescription($beschreibung);
          $artikel->setAuthorName($autor_name);
          $artikel->setAuthorMail($autor_mail);
          $artikel->setAuthorXtra($autor_telefon);
          $artikel->setAuthorComment($autor_bemerkung);
          $artikel->setCategory($kategorie);
          $artikel->save("uploadData");
        }
        else
        {
          die("PROBLEM: Datei '".$artikelID.".article' scheint nicht im Verzeichnis uploadData zu existieren");
        }
        /*

      // Benutze $artikelID !!!!!!!!!!!

      // ---- Eingaben speichern
      if ($fp = fopen("uploadData/".$orgFilename.".inf","w+"))
      {
        fwrite($fp,addslashes($titel)."\n");
        // 4. Beschreinung
        fwrite($fp,addslashes($beschreibung)."\n");
        // 5. Autor Name
        fwrite($fp,addslashes($autor_name)."\n");
        // 6. Autor Mail
        fwrite($fp,addslashes($autor_mail)."\n");
        // 7. Autor Telefon
        fwrite($fp,addslashes($autor_telefon)."\n");
        // 8. Autor Bemerkung
        fwrite($fp,addslashes($autor_bemerkung)."\n");
        // 9. Kategorie
        fwrite($fp,addslashes($kategorie)."\n");

        fclose($fp);
      }
      else
      { die("\nFEHLER: In Verzeichnis 'uploadData' koennen keine Dateien angelegt werden. Bitte Schreibrechte pruefen.");}

      */

      // ---- MP3 ID-Tag Edit

      $ID3 = new ID3v1x("uploadData/".$orgFilename);
      $ID3->write_tag(1, strip_tags($titel), strip_tags($PODCAST_NAME), strip_tags($kategorie), date("Y",time()), substr(HTTP_BASISADRESSE,0,strlen(HTTP_BASISADRESSE)-1), "0", "37");

      // --------------------

      if ($_SESSION['admin'] != "ADMIN")
      {

      if ($EMAIL_BENACHRICHTIGUNG == "JA")
      {
        @mail($ADMIN_EMAIL, "Neuer PODCAST-Beitrag im System: ".$PODCAST_NAME, "Es liegt ein neuer Podcast im Uploadverzeichnis bereit.\n\nTitel:'".$titel."'\n\nDies ist eine automatische Benachrichtigung.");
      }

      // Template-Seite ausgeben
      $smarty->display($LAYOUT_ID.'/upload_3.tpl');

      } // enf if ADMIN
      else
      {
      ?>
        <html>
        <head>
        <meta http-equiv="refresh" content="0; URL=admin.php">
        <title>Weiterleitung ...</title>
        </head>
        <body><br>
        <center><a href='admin.php'>Klick hier ...</a></center>
        </body>
        </html>
      <?
      } // end else !ADMIN
    } // end if titel !=""
    else
    {
     ?>
        <html>
        <head>
        <?
          print '<meta http-equiv="refresh" content="0; URL=upload.php?step=2&filename='.urlencode($filename).'">';
        ?>


        <title>Weiterleitung ...</title>
        </head>
        <body><br>
        <center>
        <?
          print "<a href='upload.php?step=2&filename=".urlencode($filename)."'>";
        ?>
        Klick hier ...</a></center>
        </body>
        </html>
     <?
    }
  } // end if step=3
  else
  {
    print ("Step:".$step);
  }

  function sonderzeichenInDateinameWandeln($CGI_upload_name)
  {
      $CGI_upload_name = str_replace(" ","_",$CGI_upload_name);
      $CGI_upload_name = str_replace("","ae",$CGI_upload_name);
      $CGI_upload_name = str_replace("","ue",$CGI_upload_name);
      $CGI_upload_name = str_replace("","oe",$CGI_upload_name);
      $CGI_upload_name = str_replace("","ss",$CGI_upload_name);
      $CGI_upload_name = str_replace("'","",$CGI_upload_name);
      $CGI_upload_name = str_replace("(","_",$CGI_upload_name);
      $CGI_upload_name = str_replace(")","_",$CGI_upload_name);
      $CGI_upload_name = str_replace("~","-",$CGI_upload_name);
      $CGI_upload_name = str_replace("@","_at_",$CGI_upload_name);
      $CGI_upload_name = str_replace("!","I",$CGI_upload_name);
      $CGI_upload_name = str_replace("\"","_",$CGI_upload_name);
      $CGI_upload_name = str_replace("","",$CGI_upload_name);
      $CGI_upload_name = str_replace("&","_und_",$CGI_upload_name);
      $CGI_upload_name = str_replace("/","_",$CGI_upload_name);
      $CGI_upload_name = str_replace("=","-",$CGI_upload_name);
      $CGI_upload_name = str_replace("?","_",$CGI_upload_name);
      $CGI_upload_name = str_replace("<","_",$CGI_upload_name);
      $CGI_upload_name = str_replace(">","_",$CGI_upload_name);
      $CGI_upload_name = str_replace("|","-",$CGI_upload_name);
      $CGI_upload_name = str_replace(";",".",$CGI_upload_name);
      $CGI_upload_name = str_replace(",",".",$CGI_upload_name);
      $CGI_upload_name = str_replace("`","",$CGI_upload_name);
      $CGI_upload_name = str_replace("","",$CGI_upload_name);
      return $CGI_upload_name;
  }

  function ggfDatumskennungHinzufuegen($CGI_upload_name)
  {
      // ggf. Datumskennung vorne anhngen, wenn erstesZeichen keine Zahl ist
      $erstesZeichen = $CGI_upload_name[0];
      if ( !( (ord($erstesZeichen)>=48) && (ord($erstesZeichen)<=57) ) )
      {
        $CGI_upload_name = date("Ymd")."_".$CGI_upload_name;
      }
      return $CGI_upload_name;
  }

  function fehlerMeldung($fehlertext)
  {
    $GLOBALS['smarty']->assign('PODCAST_fehlerText',$fehlertext);

    // Template-Seite ausgeben
    $GLOBALS['smarty']->display($GLOBALS['LAYOUT_ID'].'/upload_error.tpl');
    exit();
  }

  // versucht Informationen aus dem ID des MP3 zu ziehen
  function getMp3Info($datei)
  {
    if (file_exists($datei))
    {

     /* neue Version (noch mit Fehlern)
     $ID3 = new ID3v1x($datei);
     if($ID3->read_tag() == true)
     {
        $infoArray['Titel']     = $ID3->title;
        $infoArray['Kuenstler'] = $ID3->artist;
        $infoArray['Album']     = $ID3->album;
        $infoArray['Jahr']      = $ID3->year;
        $infoArray['Kommentar'] = $ID3->track;
        $infoArray['Genre']     = $ID3->genre;
        return $infoArray;
     }
     else
     {
       return false;
     }
     */

    /* ALTE VERSION */

        $fp = fopen($datei, "r");
        fseek($fp, (filesize($datei) - 128));
        $tag = fread($fp,3);

        if ($tag == "TAG")
        {
            // ID-Tag gefunden ; Informationen auslesen
            $infoArray['Titel']     = charfilter(fread($fp, 30));
            $infoArray['Kuenstler'] = charfilter(fread($fp, 30));
            $infoArray['Album']     = charfilter(fread($fp, 30));
            $infoArray['Jahr']      = charfilter(fread($fp, 4));
            $infoArray['Kommentar'] = charfilter(fread($fp, 30));
            $infoArray['Genre']     = charfilter(fread($fp, 1));
            fclose($fp);
            return $infoArray;
        }
        else
        {
          // Kein ID-tag gefunden
          fclose($fp);
          return false;
        }

    }
    else
    {
      return false;
    }
  }
?>